﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Data

Namespace System
   Public Module EnumX

      ''' <summary>a typed wrapper around Enum.GetValues</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Function EnumGetValues(Of T As Structure)(enm As T) As T()
         Return DirectCast([Enum].GetValues(enm.GetType), T())
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function AndChangeAdd(dataRowAction As DataRowAction) As DataRowAction
         Return dataRowAction And (Data.DataRowAction.Add Or Data.DataRowAction.Change)
      End Function

      <DebuggerStepThrough(), Extension()> _
      Public Function AndDeletedDetached(dataRowState As DataRowState) As DataRowState
         Return dataRowState And (dataRowState.Deleted Or dataRowState.Detached)
      End Function

   End Module

End Namespace

