﻿#Region "FileHeader"
#If False Then
Wenn durch MouseDrag oder Doppelklick bestimmt, selectiert RichTextBox ganze Worte ohne '_', aber mit TrailingSpaces.
Und auch das buggy - manchmal selectierts noch was anderes
Hingegen Textbox selectiert den MouseDrag korrekt und ohne Fissimatenten
Ich will aber ganze Worte + '_'
#End If '-- Options, Imports
Imports System.Text.RegularExpressions
#End Region 'FileHeader

Namespace System.Windows.Forms
	''' <summary>Bei gehaltener Ctrl werden ganze Worte + '_' selectiert, ohne TrailingSpaces</summary>
	Public Class WordSelectBehavior

		Private WithEvents _TextBox As TextBoxBase
		Public Sub New(TextBox As TextBoxBase)
			_TextBox = TextBox
		End Sub

		Private Shared _rgxWrdEnd As New Regex("\w*")
		Private Shared _rgxWrdStart As New Regex("\w*", RegexOptions.RightToLeft)

		Private Sub _TextBox_MouseUp(sender As Object, e As MouseEventArgs) Handles _TextBox.MouseUp
			If Not Control.ModifierKeys.HasFlag(Keys.Control) OrElse e.Button <> MouseButtons.Left Then Return
			Dim i = _TextBox.SelectionStart
			Dim txt = _TextBox.Text
			Dim wrdStart = _rgxWrdStart.Match(txt, i)
			If _TextBox.SelectionLength > 0 Then
				For i = _TextBox.SelectionStart + _TextBox.SelectionLength - 1 To _TextBox.SelectionStart + 1 Step -1
					If txt(i) <> " "c Then i += 1 : Exit For
				Next
			End If
			Dim wrdEnd = _rgxWrdEnd.Match(txt, i)
			_TextBox.Select(wrdStart.Index, wrdEnd.Index + wrdEnd.Length - wrdStart.Index)
		End Sub
	End Class

End Namespace
